#ifndef BBU_OPERATION_H
#define BBU_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include "OperationBaseClass.hpp"
#include "BBUDAPI.hpp"

using namespace std;


class BBUOperation: public OperationBaseClass
{
    public:
                BBUOperation(OPERATION_TYPE, string);
       virtual  ~BBUOperation();

                //Decide which operation to be executed
                int  executeOperation(StringParser);

                //Operation implement here
                int  monitor(StringParser);
                int  read(StringParser);
                int  write(StringParser);
                int  on(StringParser);
                int  off(StringParser);
                int  showCharge(StringParser);

                //Show parameter message here
                int  Help_parameter(StringParser);

                //Check parameter syntax here
                int  Syntax_check(StringParser);

    private:

};

#endif
