/*******************************************************************************

NAME			$RCSfile: module.c,v $
SUMMARY			Memory Diagnostics for Crystal Beach DMA units
VERSION			$Revision: 1.7 $
UPDATE DATE		$Date: 2010/04/28 06:22:52 $
PROGRAMMER		$Author: lecter $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:
    Contains the diagnostic functions for the register test and the interrupt test.

REFERENCE:

*******************************************************************************/

#include <linux/module.h>	/* Needed by all modules */
#include <linux/kernel.h>	/* Needed for KERN_INFO */
#include <linux/mm.h>


int init_module(void)
{
	printk(KERN_INFO "DMA Diag Code\n");
	return 0;
}

void cleanup_module(void)
{
	printk(KERN_INFO "Goodbye world 1.\n");
}

MODULE_AUTHOR( "shawn.wang@netapp.com" );
MODULE_DESCRIPTION( "NetApp DMA Diag Code" );
MODULE_LICENSE( "GPL v2" );
MODULE_VERSION( "0.1" );

