/*******************************************************************************

NAME            pchLpcDiag.h
SUMMARY         header file for Ibex Peak LPC interface function diagnostics
VERSION         %version: 1 %
UPDATE DATE     %date_modified: Jun 5 15:00 2009 %
PROGRAMMER      %created_by:    Jim Tu %

        Copyright 2009 Quanta Corporation. All Rights Reserved.

DESCRIPTION:
        This file has code to test Ibex Peak LPC interface

NOTES:

REFERENCE:

*******************************************************************************/

#ifndef __PATSBURG_DEFINE_H__
#define __PATSBURG_DEFINE_H__

#if defined(CTRLER_SOYUZ) || defined(CTRLER_TAHOE)
#define INTEL_PATSBURG_LPC_DEVICE_ID			0x1d40

#define PATSBURG_RCBA_OFFSET				0xF0
#define PATSBURG_DMI_LSTS_OFFSET			0x21A9


#define PATSBURG_PCIE_LSTS_OFFSET			0x52
#define PATSBURG_RCBA_LENGTH				0x3A8B

#define PATSBURG_PCIE_X4_LINK_WIDTH			0x41
#define PATSBURG_PCIE_X2_LINK_WIDTH			0x21
#define PATSBURG_PCIE_X1_LINK_WIDTH			0x11
#else  //if defined(CTRLER_SOYUZ)
#define INTEL_PATSBURG_LPC_DEVICE_ID			0x3B14

#define PATSBURG_RCBA_OFFSET				0xF0
#define PATSBURG_DMI_LSTS_OFFSET			0x01A9


#define PATSBURG_PCIE_LSTS_OFFSET			0x52
#define PATSBURG_RCBA_LENGTH				0x35B4

#define PATSBURG_PCIE_X4_LINK_WIDTH			0x41
#define PATSBURG_PCIE_X2_LINK_WIDTH			0x21
#define PATSBURG_PCIE_X1_LINK_WIDTH			0x11



#endif //if defined(CTRL_SOYUZE)
#endif	//__IBX_LPC_DIAG_H__

