/****************************************************************************
*                                                                           *
* Copyright 2004-2011 NetApp Inc. All rights reserved. This file is         *
* confidential and a trade secret of NetApp. The receipt or possession of   *
* this file does not convey any rights to reproduce or disclose its         *
* contents or to manufacture, use, or sell anything it may describe, in     *
* whole, or in part, without the specific written consent of NetApp.        *
*                                                                           *
****************************************************************************/
/****************************************************************************
*                                                                           *
* NAME            mapidrv.h                                                 *
* SUMMARY                                                                   *
* VERSION         %version: %                                               *
* UPDATE DATE     %date_modified: %                                         *
* PROGRAMMER      %created_by:    Kyle McIntire %                           *
*                                                                           *
*        Copyright 2002-2011 NetApp Inc.. All Rights Reserved.              *
*                                                                           *
* DESCRIPTION:                                                              *
*                                                                           *
****************************************************************************/
#define FPGASYS_VERSION		" 0.0.1"
#define FPGASYS_SHORT_NAME	"fpga-reg"
#define FPGASYS_LONG_NAME	"NetApp MTD FPGA Access Driver"
#define FPGASYS_DEVICE_NAME	FPGASYS_SHORT_NAME
#define FPGASYS_KOBJ_NAME	"fpga-rgstr"
#define FPGASYS_DEVNUM_BUF	5

//-------------------------------------------------------
// Macros
//-------------------------------------------------------
#define	PACKED					__attribute__((packed))

//-------------------------------------------------------
// Structures
//-------------------------------------------------------

//-------------------------------------------------------
// Prototypes
//-------------------------------------------------------
struct kobject *fpgasysGetRootKobj( void );
int fpgasysEntryInitialize( void );
void fpgasysEntryDeinitialize( void );
int fpgasysRegisterInit( void );
void fpgasysRegisterDeinit( void );
int fpgasysEppInit( void );
void fpgasysEppDeinit( void );
