#include "SATAModule.hpp"

SATAModule::SATAModule(string className) : ModuleBaseClass(className)
{
    //Add NEW command, new I2CCommand(command name, HELP message)
    addCommand(new SATACommand(CMD_LIST, "List Supported SATA Devices"));
    addCommand(new SATACommand(CMD_SHOW, "Show SATA Device Information"));
    addCommand(new SATACommand(CMD_TEST, "Read or Write Test Performance from SATA device"));
    addCommand(new SATACommand(CMD_ERROR, "Get Error Statistics from SATA device"));
    addCommand(new SATACommand(CMD_UTILITY, "Get SMART Information from SATA device"));
}

SATAModule::~SATAModule()
{

}
