
#ifndef __Expander_DIAG_H__
#define __Expander_DIAG_H__

#define	EXPANDER_FLASH_SIZE							0x400000 		/* 4M */
#define EXPANDER_FLASH_ADDRESS_LINE					22
#define	EXPANDER_FLASH_DIAG_OFFSET_1				0x240000
#define	EXPANDER_FLASH_DIAG_OFFSET_2				0x200000
#define EXPANDER_FLASH_DATA_LINE					8
#define	EXPANDER_FLASH_ADDRESS						0x14000000
#define EXPANDER_FLASH_SECTOR_SIZE_8K				0x2000 			/*  8K */
#define EXPANDER_FLASH_SECTOR_SIZE					0x10000         /* 64K */
#define EXPANDER_BACKUP_BUFFER_START_PHYADDRESS		128*1024*1024
#define EXPANDER_FLASH_MX29LV320D					0xA7
#define EXPANDER_FLASH_FW_BACKUP_SIZE				0x180000        /* 1.5 MB */
#define EXPANDER_FLASH_SECTOR_COUNT					0x3F
#define EXPANDER_FLASH_64K_FIRST_SECTOR_ADDRESS		0x10000
//#define EXPANDER_FLASH_8K_FIRST_SECTOR_ADDRESS		0x3F0000
#define EXPANDER_FLASH_8K_LAST_SECTOR_ADDRESS		0xFFFF
#define EXPANDER_FLASH_ERROR_RETRY					10



/* Pubplic Flash Diag Api  */
INT32 WalkingSectorExpanderDg(void);
INT32 ExpFlashAdrDg(void);
INT32 ExpFlashDLDg(void);
INT32 BackupFromFlashExpander(void);
INT32 BackupToFlashExpander(void);
INT32 ImageProgramExpander(UINT32 offset, UINT32 len, UINT8 *data);
INT32 ExpProgramFlash(UINT32 offset, UINT32 len, UINT8 *data);

#endif
