/*******************************************************************************

NAME			$RCSfile: commSysInfo.h,v $
SUMMARY			Header file of Global variables for System Information
VERSION			$Revision: 1.5 $
UPDATE DATE		$Date: 2009/10/07 06:15:30 $
PROGRAMMER		$Author: jim $

		Copyright 2009 LSI Corporation. All Rights Reserved.

DESCRIPTION:

REFERENCE:

*******************************************************************************/
#include <commTypes.h>

/* SYSTEM INFORMATION */
#define SINGLE_CONTROLLER	0
#define DUAL_CONTROLLER		1
PUBLIC UINT32 sysDualCtrl;

#define ROLE_UUT		0
#define	ROLE_FIXTURE	1
PUBLIC UINT32 sysCtrlRole;
PUBLIC UINT32 sysDualCtrl;

#define DAUGHTER_DIAG	1
#define MAINBOARD_DIAG	0

PUBLIC UINT32 sysDiagPart;

typedef enum host_card_type {
	HOST_CARD_NONE = 0,
	HOST_CARD_FC,
	HOST_CARD_ISCSI,
	HOST_CARD_IB,
	HOST_CARD_SAS
} HOST_CARD_TYPE;
PUBLIC HOST_CARD_TYPE sysHostCardType;

PUBLIC UINT32 sysMidplaneType;

/* NIC INFORMATION */
#define PIKES_PEAK_NIC_PORTS    3
#define NIC_BS_TX_SIZE          1536
#define NIC_BS_UDP_PORT         2266
PUBLIC UINT32 nicRemoteHostIP[PIKES_PEAK_NIC_PORTS];
PUBLIC VOID sysFixtureReadyReply(VOID);
PUBLIC VOID sysFixtureReadyRequest(VOID);
